<?php 
session_start( );
#
$SITE 			= array();	// to store all settings for all scripts
$pathString		= '';		// to store messages form scripts before echo can be used
#
# -------- some checking and saving our path ---------------------------------------------
# in every module loaded the modulename and version is saved and checked to see
# if the modulename in the source equals the module loaded
# this info is saved for all modules and printed at the end of the html for debugging purposes
#
# In all modules loaded after index.php we check if the module is loaded via index.php
# If someone tries to execute a module by typing its name in the adressarea of the browser 
# we redirect to index.php
# ----------------------------------------------------------------------------------------
$pageName						= 'index.php';					// the name of this module 
$pageVersion					= '2.01 2013-01-31';			// the version
$SITE['wsModules'][$pageName]	= 'version: ' . $pageVersion;	// we save it in our site array
$pageFile 						= basename(__FILE__);			// get the real name of the loaded script
if ($pageFile <> $pageName) {									// check to see if the names are the same
	$SITE['wsModules'][$pageFile]= 'this file loaded instead of '.$pageName; // if not we save this also
}										
$pathString.= '<!-- module '.$pageFile.' ==== '.$SITE['wsModules'][$pageFile]." -->".PHP_EOL;  // echo all modulenames loaded
#-----------------------------------------------------------------------------------------
# version history  release 2
# 2.01  2013-01-31	First version of 2.0 release /cleaned
#
#-----------------------------------------------------------------------------------------
#
$lang			= 'nl';											// default language
#
#-------------- check debug settings -----------------------------------------------------
$wsDebug		= true;											// no debug is default, set for testing to true
$extraP			= '';
if (isset($_REQUEST['debug']) || $wsDebug == true) {
	$wsDebug	= true;
	ini_set('display_errors', 'On'); 
	error_reporting(E_ALL);	
	$pathString.= '<!-- debug is switched on by user request - error reporting ALL -->'.PHP_EOL;
	if (isset($_REQUEST['wp'])) {
		$wp = strtoupper($_REQUEST['wp']);
		if ($wp == 'WD' || $wp == 'WL' || $wp == 'MH' || $wp == 'CU') {
			$SITE['WXsoftware'] = $wp;
			$pathString.= '<!-- user switches the weatherprogram to '.$wp.' -->'.PHP_EOL;
			$extraP='&amp;wp='.$wp;
		}
		
	}
}
#
# -------- first we load the sitewide settings we need from now on 		------------------
require_once("wsSettings.php");									// weather program settings are loaded by this script also
#
# maybe an older version is used or the website owner changed these settings
# we do not want any php errors so we create the missing settings
#
if (!isset($SITE['stripAll']))			{$SITE['stripAll']		= false;}
#										// generate html without headers footers sidecolomn but include menu
if (!isset($SITE['stripMenu']))			{$SITE['stripMenu']		= false;}
#										// generate html without menu
if (!isset($SITE['cookieSupport']))		{$SITE['cookieSupport'] = true;}
#
if (!isset($SITE['mobileSite']))		{$SITE['mobileSite']	= '';}
#
if (!isset($SITE['charset'])) 			{$SITE['charset'] = 'ISO-8859-1'; }										// leave '' as otherwise it is treated as an url
#
# ------------------------   check if we are allowed to set cookie and process all cookies
if ($SITE['cookieSupport'] == true) {
	include('wsCookie.php');
}
# -----------------------------------------------------  check if we go to the mobile site
if ($SITE['mobileSite'] <> "") {
	$mobi 	= false;
	$cookie = $SITE['cookieName']."skip";
	if (!isset ($_COOKIE[$cookie])) {
		require_once('./mobi/mobile_device_detect.php');		// credits : http://detectmobilebrowsers.mobi/
		$mobile =	mobile_device_detect(true,false,true,true,true,true,true,'','');
		if ($mobile) {
			if (!isset ($_REQUEST['mobi']) ) { 
				$mobi = 10;
				wsSetcookie($cookie, "skip", time()+3600);  // if users returns in 60 min, the normal site will be used
			}
			if (isset ($_REQUEST['pcSite']) || isset ($_SESSION['pcSite']) ) {
				$_SESSION['pcSite']	= 'Y';
				$mobi = false;
			}
		}
	} 
	if (isset ($_REQUEST['mobi']) ) {   // pc user wants to go to mobile site
		$mobi = intval ( trim($_REQUEST['mobi']));
	}
	if ($mobi <> false) {
		include($SITE['mobileSite']);
		exit;			// user 
	}
}
#------------------------  now we are processing requests for pages on our  normal website
# A template set for personal weather stations
# Developer :	(c) 2011 Weerstation Leuven. Based on previous scripts o.a. from Ken True (Saratoga.org)
# Use and adapt as you wish.
#
#Module summary:
# 1.	wsSetting.php 				sitewide settings
# loads	settingsWeather.php			weathersoftware settings
#
# 2		wsCookie.php				check cookies set and registers if we are allowed to set cookies
#
# 3.	wsLangFunctions.php			language translation functions
#
# 4. 	wsMenuLoad.php				fills array with all menu choices and extras from incMenuData.xml
#
# 5. 	wsGetdata					process all variables from the weatherprogram into array with values
# loads wsLoaddata  				generates table with weathervalues to be used in Ajax/Javascript updates
#
# 6. 	
#
# 7.	Footer	the footer includes also WhoIsOnline functions etc.
#
require_once($SITE['langFunc']);			// so we can translate  to required lang
#
$titleOfPage = langtransstr($SITE['organ']) . " - " .langtransstr('Start page'); 
#
#-----------------------------------------------------------------------------------------
#	decide which page to load based on the users input      
#-----------------------------------------------------------------------------------------
$p = $SITE['noChoice'];
if (isset($_GET['p'])) {
	$p = $_GET['p'];	
}elseif (isset($_POST['p'])) {
	$p = $_POST['p'];		
}
if ( isset ($_POST['donotwant']) ) {$p = $SITE['noChoice'];}  // if user reject cookie, goback to startpage
#-----------------------------------------------------------------------------------------
#	load menu data into $menuArray for pagenumber checking and into a HTML string 
#-----------------------------------------------------------------------------------------
require_once($SITE['menuLoad']);
#
if (isset($menuArray[$p]['choice'])) {	// valid page number
	$folder 		= $menuArray[$p]['folder']; 
	$gizmo  		= $menuArray[$p]['gizmo'];
	$css			= $menuArray[$p]['css'];
	$head			= $menuArray[$p]['head'];
	$link			= $menuArray[$p]['link'];
	$titleOfPage	= langtransstr($menuArray[$p]['title']). " - ".langtransstr($SITE['organ']);
	$phpself		= "index.php?p=".$p;// if a page wants to reload itself later it uses this var because a page does not know its menunumber
} else {
	header ("Location: index.php");		// back to index/startpage if someone tries an
	exit;  								//  out of range / non existing page
}
#-----------------------------------------------------------------------------------------
#            generate headers and first part of page
/*

echo'<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
	"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

*/

#-----------------------------------------------------------------------------------------
header("Content-Type: text/html; charset=".strtoupper($SITE['charset']));
echo'<!DOCTYPE html><html>
<head>'.PHP_EOL;
echo $pathString;    					// print list of loaded modules until this point
$pathString	= '';						// and reset for further use
$htmlTxt	= '';						// in this string we assemble the html output
#-----------------------------------------------------------------------------------------
# javascript for gizmo.This is in header1 a one line high weather description with rotating content: temp / baro a.s.o.
# 		or  a set of weather variables boxes in header2
# the gizmo is only shown on a page if requested in the menu file entry for that page
#	AND if allowed by the settings
#-----------------------------------------------------------------------------------------
if ($gizmo) {   									// menu file request a gizmo for this page, if also it is set in site-settings 
	if (isset($SITE['ajaxGizmoShow']) and $SITE['ajaxGizmoShow']) {	
													// and it is set in site-settings , than display it
		$htmlTxt.='	<script type="text/javascript" src="'.$SITE['ajaxGizmojs'] .'"></script>'.PHP_EOL;
		if (!isset($SITE['UV']) || !$SITE['UV']) {	// turn of display of UV value if no UV sensor present
			$htmlTxt.='	<script type="text/javascript"> showUV = false; </script>'.PHP_EOL;
		} // end of turn gizmo UV display off
#	
		if(isset($SITE['wsAjaxScript'])) { 			// is there a realtime update script for this site allowed
			$htmlTxt.='	<script type="text/javascript">
		var url = "'.$SITE['wsAjaxDataLoad'].'?wp='.$SITE['WXsoftware'].'";   
		var reloadTime 	= '.$SITE['wsAjaxDataTime'].'000;
	</script>'.PHP_EOL;
			$htmlTxt.='	<script type="text/javascript" src="'.$SITE['wsAjaxScript'].'"></script>'.PHP_EOL;
		} 	// end if ajaxScript
	} // end of showGizmo for this site
} // end of gizmo for this page
#
$htmlTxt.= '	<script type="text/javascript" src="javaScripts/styleMenu.js"></script>'.PHP_EOL;
if (isset ($SITE['autoRefresh'])  &&  $SITE['autoRefresh'] > 60 ){
	$htmlTxt.= '	<meta http-equiv="refresh" content="'.$SITE['autoRefresh'].'" />'.PHP_EOL;
}
$htmlTxt.= '	<meta name="description" content="'.$titleOfPage.'" />'.PHP_EOL;
$htmlTxt.= '	<meta http-equiv="Content-Type" content="text/html; charset='.strtoupper($SITE['charset']).'"/>'.PHP_EOL;
echo $htmlTxt;
#-----------------------------------------------------------------------------------------
#            standard stylesheets
#-----------------------------------------------------------------------------------------
$htmlTxt ='	<link rel="stylesheet" type="text/css" href="'.$SITE['CSSscreen'].'" media="all" title="screen" />'.PHP_EOL;
$htmlTxt.='	<link rel="stylesheet" type="text/css" href="'.$SITE['CSStable'].'" media="all" title="screen" />'.PHP_EOL;
if ($SITE['stripAll'] || $SITE['menuPlace'] == 'H') {
	$htmlTxt.='	<link rel="stylesheet" type="text/css" href="'.$SITE['CSSmenuHor'].'" media="all" title="screen" />'.PHP_EOL;
} else {
	$htmlTxt.='	<link rel="stylesheet" type="text/css" href="'.$SITE['CSSmenuVer'].'" media="all" title="screen" />'.PHP_EOL;
}
#------------------------------------------------------------------------------------------
#   extra stylesheet for this menuchoice
#------------------------------------------------------------------------------------------
if ($css <> ''){
	$htmlTxt.='	<link rel="stylesheet" type="text/css" href="'.$css.'" media="all" title="screen" />'.PHP_EOL;
}
$htmlTxt.='	<link rel="stylesheet" type="text/css" href="'.$SITE['CSSmood'].'" media="all" title="screen" />'.PHP_EOL;
$htmlTxt.='	<link rel="stylesheet" type="text/css" href="'.$SITE['CSSprint'].'" media="print" />'.PHP_EOL;
#-----------------------------------------------------------------------------------------
# other header lines 
#-----------------------------------------------------------------------------------------
$htmlTxt.='	<link rel="shortcut icon" href="img/icon.png" type="image/x-icon" />
	<meta name="Keywords" content="weather, Weather, temperature, dew point, humidity,
	 forecast, Davis Vantage Pro,  Weather, '.$SITE['organ'].', weather conditions, 
	 live weather, live weather conditions, weather data, weather history, Meteohub " />
	<title>'.$titleOfPage.'</title>'.PHP_EOL;
echo $htmlTxt;							// now all header text is sent
#-----------------------------------------------------------------------------------------
# general functions used in all scripts
#-----------------------------------------------------------------------------------------
echo '<!-- '.'index.php'.' load script with general functions used in all scripts  -->'.PHP_EOL;
include_once($SITE['functions']);		// general functions for data processing
echo $pathString;
$pathString		= '';					// reset for further use
#-----------------------------------------------------------------------------------------
# a different script for every supported weather program is used to convert weatherdata
#-----------------------------------------------------------------------------------------
echo '<!-- '.'index.php'.' get data from weatherprogr / wu sites / metar files -->'.PHP_EOL;;
include_once($SITE['getData']);			// get data from weatherprogr / wu sites / metar files
#
echo '<!--'.'index.php'.' load all weatherdata into a javascript string -->'.PHP_EOL;
include_once($SITE['loadData']);		// load weatherdata in string (=array)for eval in javascript
$vars = array();
$string2=str_replace('ajaxVars','$vars',$string1);  // change javascript to php
eval($string2);							// all vars for use in headings and ajax "normal" pages are now loaded into $vars array
#-----------------------------------------------------------------------------------------
#	do we want a colored background a.s.o.
#-----------------------------------------------------------------------------------------
if ($SITE['colorNumber'] <>  0) {		// fixed color scheme (1 and higher) overrides dynamic (0) based on weather conditions
	$headerClass = $SITE['colorStyles'][$SITE['colorNumber']];	
}
echo 	"<!-- 'index.php' icoon = $ccnIconNr  , hdrclass = $headerClass -->".PHP_EOL;
#-----------------------------------------------------------------------------------------
# we calculate the width of the page and the width of the usable area
#-----------------------------------------------------------------------------------------
#
if (isset($SITE['pageWidth'])) { $pageWidth = $SITE['pageWidth'];} else { $pageWidth	= '1000';}
if (isset($SITE['menuWidth'])) { $menuWidth	= $SITE['menuWidth'];} else { $menuWidth	='140';}
$areaWidth = $pageWidth - 10;
if ($SITE['sideDisplay'] || $SITE['menuPlace'] <> 'H') {
	$areaWidth	= $pageWidth - $menuWidth - 10;// usable area = pagewidth minus optional menu/sidecolom width
}
#-----------------------------------------------------------------------------------------
#---  extras for the html head section go between here   ---------------------------------
#
if ($head <> ''){					// extras to be included based on the menu settings F.i. generate a special css a.s.o.
#	if (($folder <> '') && ($folder <> './')) {$SITE['docRoot'] = '../'; chdir ($folder);}
	include($head); 				// load  /execute the requested extra's
#	chdir ('../');
#	$SITE['docRoot'] = './';
}
if (!isset($EWNHEAD) ) {				// EWN cannot run with this code, it has its own version of it
echo '<script type="text/javascript">
var docready=[],$=function(){return{ready:function(fn){docready.push(fn)}}};
</script>
'.PHP_EOL;
}
#
#---------  and here     -----------------------------------------------------------------
echo '</head>'.PHP_EOL;
echo '<body class="'.$headerClass.'">'.PHP_EOL;
#-----------------------------------------------------------------------------------------
# Now we set a picture as background based on the  settings
#-----------------------------------------------------------------------------------------
$fileString='img/background-'.$headerClass.'.jpg';
if (file_exists($fileString)) {
	echo '<img src="'.$fileString.'" class="bg" alt="" />'.PHP_EOL;
}
#-----------------------------------------------------------------------------------------
# we start outputting the page
#-----------------------------------------------------------------------------------------
echo '<!-- page wrapper -->
<div id="pagina" style="width:'.$pageWidth.'px; position: relative; z-index: 2;">'.PHP_EOL;
#-----------------------------------------------------------------------------------------
# Warnings boxes
if (!isset($SITE['warningInside'])) { 
	$SITE['warningInside'] = false;}
elseif ($SITE['warningInside'] <> true) {
	include ('wsWarning.php');} 
#
if (!$SITE['stripAll']) { 				// a normal page incl headers footers and (optional/default) a menu
	#-------------------------------------------------------------------------------------
	#  header either low (type 1)  or 2 = default
	#-------------------------------------------------------------------------------------
	$header			= 2;				// default header = 2
	if ( isset($SITE['header']) ){
		$header		= $SITE['header'];	//  which header 1 or 2
	}
	include ("wsHeader$header.php");
	#-------------------------------------------------------------------------------------
	#  where do we place the menu
	#-------------------------------------------------------------------------------------
	if (!$SITE['stripMenu'] && $SITE['menuPlace'] == 'H') { // no strip menu and horizontal
	#  									// horizontal menu
		echo '<div id="menu-hor" style="width: '.$areaWidth.'px; margin: 5px 5px 0px 5px;">'.PHP_EOL;
		echo '<ul id="nav">'.PHP_EOL;
		echo $DropdownMenuText;
		echo '</ul>'.PHP_EOL;
		echo '</div>'.PHP_EOL;
	} 
	if ($SITE['sideDisplay'] || $SITE['menuPlace'] <> 'H') {	// vertical menu in side area
	#  									//  vertical menu in side area
		echo '<!-- first colomn with links to external sites and or vertical menu-->'.PHP_EOL;
		echo '<div id="info-ver">'.PHP_EOL;
		include_once($SITE['sideInc']);
		echo '</div>'.PHP_EOL;   		//
		echo '<!-- end first colomn -->'.PHP_EOL;
		$areaWidth =  $pageWidth - $menuWidth - 10;	// subtract menu width and 10px margin	
	}
} else {   								// strip all extras but do we want a menu?
	if (!$SITE['stripMenu']) {
		echo '<div id="menu-hor" style="width: '.$areaWidth.'px;">'.PHP_EOL;	// only a horizontal menu is possibles as there is no sidecolom etc
		echo '<ul id="nav">'.PHP_EOL.$DropdownMenuText;
		echo '</ul>'.PHP_EOL;
		echo '</div>'.PHP_EOL;
	}
}
echo '	<div id="data-area" style="width: '.$areaWidth.'px; ">'.PHP_EOL;
# 
if ($SITE['warningInside']) {include ('wsWarning.php');} // check for warnings if not already done
#---------------------------------------------------------------------------
#		load the requested page from directory 
#
echo '<!--  load program: '.$link.' -->'.PHP_EOL;
#if ($folder <> './') {
#	$SITE['docRoot'] = '../';
#	include($folder.$link);				// load the requested page form its folder
#	$SITE['docRoot'] = './';
#} else {
	include($link); 					// load the requested page from the root ?
#}
#$SITE['docRoot'] = $folder = './';
echo'	</div>
<!-- end data area -->'.PHP_EOL;
#---------------------------------------------------------------------------
#		bottom area and footer
#
if (!$SITE['stripAll'] && $SITE['bottomDysplay']) {	// optional bottom area
	echo '	<div id="bottom" class="doNotPrint">'.PHP_EOL;
	include ($SITE['bottomInc']);
	echo '	</div>'.PHP_EOL;
}
if (!$SITE['stripAll']) {
	include($SITE['footer']);  // always the footer with optional whoisonline
} else {
	echo '&nbsp;';
}
?>
</div>
<!-- end id="page" wrapper -->
<!--
<?php 
echo '_____________________________|_____________________________'.PHP_EOL;
echo '              loaded modules | version number'.PHP_EOL;
echo '_____________________________|_____________________________'.PHP_EOL;
foreach ( $SITE['wsModules'] as $key => $val) {
	echo substr('                       '.$key.' | ',-31,31).$val.PHP_EOL;
}
echo '_____________________________|_____________________________'.PHP_EOL;
?>
-->
 </body>
</html>
<?php 
#
# Leave this code here .. it will help you see what language translations are missing by running any page on your
# website with a ?show=missing argument
#
$langfile	= '';
$string		= '';
if(isset($_REQUEST['show']) and strtolower($_REQUEST['show']) == 'missing') {
	echo '<!-- '.'index.php'.' missing langlookup entries for lang='.$lang.PHP_EOL;
	foreach ($missingTrans as $key => $val) {
		$string.= "langlookup|$key|$key|".PHP_EOL;
	}
	if (strlen($string) > 0) {
		echo $string;
		if ($wsDebug) {
			$langfile 	= './lang/wsLanguage-' . $lang .'-local.txt';
			file_put_contents($langfile,$string,FILE_APPEND);
		}
	}
	echo count($missingTrans).' entries.  End of missing langlookup entries -->'.PHP_EOL;
}
# -------------------- function only for index.php
function wsSetcookie ($cookie, $doSomething,$time) {
	global $cookieAllowed;
	if ($cookieAllowed == true) {
		setcookie($cookie, $doSomething, $time); // cookie expires in 1 hour
	} else {
		echo 'cookie set without consent'; exit;
	}
	return;
}

?>
